Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -7866,488 +7926,699 @@
 !> ------------
 !> Define aerosol fluxes: constant or read from a from file
-!------------------------------------------------------------------------------! 
- SUBROUTINE salsa_set_source
- 
- !   USE date_and_time_mod,                                                     &
- !       ONLY:  index_dd, index_hh, index_mm
+!> @todo - Emission stack height is not used yet. For default mode, emissions
+!>         are assumed to occur on upward facing horizontal surfaces.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_emission_setup( init )
+
+    USE control_parameters,                                                                        &
+        ONLY:  time_since_reference_point
+
+    USE date_and_time_mod,                                                                         &
+        ONLY:  day_of_month, hour_of_day, index_dd, index_hh, index_mm, month_of_year,             &
+               time_default_indices, time_utc_init
+
+    USE netcdf_data_input_mod,                                                                     &
+        ONLY:  check_existence, get_attribute, get_variable, inquire_num_variables,                &
+               inquire_variable_names, netcdf_data_input_get_dimension_length, open_read_file
+
+    USE surface_mod,                                                                               &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=80) ::  daytype = 'workday'  !< default day type
+    CHARACTER(LEN=25) ::  in_name              !< name of a gas in the input file
+    CHARACTER(LEN=25) ::  mod_name             !< name in the input file
+
+    INTEGER(iwp) ::  ib        !< loop index: aerosol number bins
+    INTEGER(iwp) ::  ic        !< loop index: aerosol chemical components
+    INTEGER(iwp) ::  id_salsa  !< NetCDF id of aerosol emission input file
+    INTEGER(iwp) ::  in        !< loop index: emission category
+    INTEGER(iwp) ::  inn       !< loop index
+    INTEGER(iwp) ::  ss        !< loop index
+
+    INTEGER(iwp), DIMENSION(maxspec) ::  cc_i2m   !<
+
+    LOGICAL  ::  netcdf_extend = .FALSE.  !< NetCDF input file exists
+
+    LOGICAL, INTENT(in) ::  init  !< if .TRUE. --> initialisation call
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  nsect_emission  !< sectional number emission
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  source_array  !< temporary source array
+
+!
+!-- Allocate source arrays:
+    DO  ib = 1, nbins_aerosol
+       IF ( init )  ALLOCATE( aerosol_number(ib)%source(nys:nyn,nxl:nxr) )
+       aerosol_number(ib)%source = 0.0_wp
+    ENDDO
+
+    DO  ic = 1, ncomponents_mass * nbins_aerosol
+       IF ( init )  ALLOCATE( aerosol_mass(ic)%source(nys:nyn,nxl:nxr) )
+       aerosol_mass(ic)%source = 0.0_wp
+    ENDDO
+
+!
+!-- Define emissions:
+
+    SELECT CASE ( salsa_emission_mode )
+
+       CASE ( 'uniform' )
+
+          IF ( init )  THEN  ! Do only once
+!
+!-           Form a sectional size distribution for the emissions
+             ALLOCATE( nsect_emission(1:nbins_aerosol),                                            &
+                       source_array(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+!
+!--          Precalculate a size distribution for the emission based on the mean diameter, standard
+!--          deviation and number concentration per each log-normal mode
+             CALL size_distribution( surface_aerosol_flux, aerosol_flux_dpg, aerosol_flux_sigmag,  &
+                                     nsect_emission )
+             DO  ib = 1, nbins_aerosol
+                source_array(:,:,ib) = nsect_emission(ib)
+             ENDDO
+!
+!--          Check which chemical components are used
+             cc_i2m = 0
+             IF ( index_so4 > 0 ) cc_i2m(1) = index_so4
+             IF ( index_oc > 0 )  cc_i2m(2) = index_oc
+             IF ( index_bc > 0 )  cc_i2m(3) = index_bc
+             IF ( index_du > 0 )  cc_i2m(4) = index_du
+             IF ( index_ss > 0 )  cc_i2m(5) = index_ss
+             IF ( index_no > 0 )  cc_i2m(6) = index_no
+             IF ( index_nh > 0 )  cc_i2m(7) = index_nh
+!
+!--          Normalise mass fractions so that their sum is 1
+             aerosol_flux_mass_fracs_a = aerosol_flux_mass_fracs_a /                               &
+                                         SUM( aerosol_flux_mass_fracs_a(1:ncc ) )
+!
+!--          Set uniform fluxes of default horizontal surfaces
+             CALL set_flux( surf_def_h(0), cc_i2m, aerosol_flux_mass_fracs_a, source_array )
+!
+!--          Subrange 2b:
+             IF ( SUM( aerosol_flux_mass_fracs_b ) > 0.0_wp )  THEN
+                CALL location_message( '   salsa_emission_setup: emissions are soluble!', .TRUE. )
+             ENDIF
+
+             DEALLOCATE( nsect_emission, source_array )
+          ENDIF
+
+       CASE ( 'parameterized' )
+!
+!--       TO DO
+
+       CASE ( 'read_from_file' )
+!
+!--       Reset surface fluxes
+          surf_def_h(0)%answs = 0.0_wp
+          surf_def_h(0)%amsws = 0.0_wp
+          surf_lsm_h%answs = 0.0_wp
+          surf_lsm_h%amsws = 0.0_wp
+          surf_usm_h%answs = 0.0_wp
+          surf_usm_h%amsws = 0.0_wp
+
 #if defined( __netcdf )
-    USE NETCDF
-    
-    USE netcdf_data_input_mod,                                                 &
-        ONLY:  get_attribute, get_variable,                                    &
-               netcdf_data_input_get_dimension_length, open_read_file
-    
-    USE surface_mod,                                                           &
-        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
- 
-    IMPLICIT NONE
-    
-    INTEGER(iwp), PARAMETER ::  ndm = 3  !< number of default modes
-    INTEGER(iwp), PARAMETER ::  ndc = 4  !< number of default categories
-    
-    CHARACTER (LEN=10) ::  unita !< Unit of aerosol fluxes
-    CHARACTER (LEN=10) ::  unitg !< Unit of gaseous fluxes
-    INTEGER(iwp) ::  b           !< loop index: aerosol number bins
-    INTEGER(iwp) ::  c           !< loop index: aerosol chemical components
-    INTEGER(iwp) ::  ee          !< loop index: end
-    INTEGER(iwp), ALLOCATABLE, DIMENSION(:) ::  eci !< emission category index
-    INTEGER(iwp) ::  g           !< loop index: gaseous tracers
-    INTEGER(iwp) ::  i           !< loop index: x-direction   
-    INTEGER(iwp) ::  id_faero    !< NetCDF id of aerosol source input file 
-    INTEGER(iwp) ::  id_fchem    !< NetCDF id of aerosol source input file                              
-    INTEGER(iwp) ::  id_sa       !< NetCDF id of variable: source   
-    INTEGER(iwp) ::  j           !< loop index: y-direction
-    INTEGER(iwp) ::  k           !< loop index: z-direction
-    INTEGER(iwp) ::  n_dt        !< number of time steps in the emission file
-    INTEGER(iwp) ::  nc_stat     !< local variable for storing the result of 
-                                 !< netCDF calls for error message handling
-    INTEGER(iwp) ::  nb_file     !< Number of grid-points in file (bins)                                  
-    INTEGER(iwp) ::  ncat        !< Number of emission categories 
-    INTEGER(iwp) ::  ng_file     !< Number of grid-points in file (gases)  
-    INTEGER(iwp) ::  nz_file     !< number of grid-points in file     
-    INTEGER(iwp) ::  n           !< loop index
-    INTEGER(iwp) ::  ni          !< loop index
-    INTEGER(iwp) ::  ss          !< loop index
-    LOGICAL  ::  netcdf_extend = .FALSE. !< Flag indicating wether netcdf 
-                                         !< topography input file or not   
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:)   :: dum_var_4d !< variable for 
-                                                              !< temporary data                                        
-    REAL(wp) ::  fillval         !< fill value 
-    REAL(wp) ::  flag            !< flag to mask topography grid points
-    REAL(wp), DIMENSION(nbins) ::  nsect_emission  !< sectional emission (lod1)
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  pm_emission  !< aerosol mass 
-                                                             !< emission (lod1)
-    REAL(wp), DIMENSION(nbins) ::  source_ijka !< aerosol source at (k,j,i)
-!
-!-- The default size distribution and mass composition per emission category:
-!-- 1 = traffic, 2 = road dust, 3 = wood combustion, 4 = other 
-!-- Mass fractions: H2SO4, OC, BC, DU, SS, HNO3, NH3
-!    CHARACTER(LEN=15), DIMENSION(ndc) ::  cat_name_table = &!< emission category
-!                                         (/'road traffic   ','road dust      ',&
-!                                           'wood combustion','other          '/)
-    REAL(wp), DIMENSION(ndc) ::  avg_density        !< average density
-    REAL(wp), DIMENSION(ndc) ::  conversion_factor  !< unit conversion factor  
-                                                    !< for aerosol emissions 
-    REAL(wp), DIMENSION(ndm), PARAMETER ::  dpg_table = & !< mean diameter (mum)
-                                            (/ 13.5E-3_wp, 1.4_wp, 5.4E-2_wp/)
-    REAL(wp), DIMENSION(ndm) ::  ntot_table                                       
-    REAL(wp), DIMENSION(maxspec,ndc), PARAMETER ::  mass_fraction_table =      &
-       RESHAPE( (/ 0.04_wp, 0.48_wp, 0.48_wp, 0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, &
-                   0.0_wp,  0.05_wp, 0.0_wp,  0.95_wp, 0.0_wp, 0.0_wp, 0.0_wp, &
-                   0.0_wp,  0.5_wp,  0.5_wp,  0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp, &
-                   0.0_wp,  0.5_wp,  0.5_wp,  0.0_wp,  0.0_wp, 0.0_wp, 0.0_wp  &
-                /), (/maxspec,ndc/) )         
-    REAL(wp), DIMENSION(ndm,ndc), PARAMETER ::  PMfrac_table = & !< rel. mass
-                                     RESHAPE( (/ 0.016_wp, 0.000_wp, 0.984_wp, &
-                                                 0.000_wp, 1.000_wp, 0.000_wp, &
-                                                 0.000_wp, 0.000_wp, 1.000_wp, &
-                                                 1.000_wp, 0.000_wp, 1.000_wp  &
-                                              /), (/ndm,ndc/) )                                   
-    REAL(wp), DIMENSION(ndm), PARAMETER ::  sigmag_table = &     !< mode std
-                                            (/1.6_wp, 1.4_wp, 1.7_wp/) 
-    avg_density    = 1.0_wp
-    nb_file        = 0
-    ng_file        = 0
-    nsect_emission = 0.0_wp
-    nz_file        = 0
-    source_ijka    = 0.0_wp
-!
-!-- First gases, if needed:
-    IF ( .NOT. salsa_gases_from_chem )  THEN    
-!       
-!--    Read sources from PIDS_CHEM      
-       INQUIRE( FILE='PIDS_CHEM' // TRIM( coupling_char ), EXIST=netcdf_extend )
-       IF ( .NOT. netcdf_extend )  THEN
-          message_string = 'Input file '// TRIM( 'PIDS_CHEM' ) //              &
-                           TRIM( coupling_char ) // ' for SALSA missing!'
-          CALL message( 'salsa_mod: salsa_set_source', 'SA0027', 1, 2, 0, 6, 0 )                
-       ENDIF   ! netcdf_extend  
-       
-       CALL location_message( '    salsa_set_source: NOTE! Gaseous emissions'//&
-               ' should be provided with following emission indices:'//        &
-               ' 1=H2SO4, 2=HNO3, 3=NH3, 4=OCNV, 5=OCSV', .TRUE. )
-       CALL location_message( '    salsa_set_source: No time dependency for '//&
-                              'gaseous emissions. Use emission_values '//      &
-                              'directly.', .TRUE. )
-!
-!--    Open PIDS_CHEM in read-only mode 
-       CALL open_read_file( 'PIDS_CHEM' // TRIM( coupling_char ), id_fchem )
-!
-!--    Inquire the level of detail (lod)
-       CALL get_attribute( id_fchem, 'lod', lod_gases, .FALSE.,                &
-                           "emission_values" ) 
-                           
-       IF ( lod_gases == 2 )  THEN
-!                              
-!--       Index of gaseous compounds
-          CALL netcdf_data_input_get_dimension_length( id_fchem, ng_file,      &
-                                                       "nspecies" )  
-          IF ( ng_file < 5 )  THEN
-             message_string = 'Some gaseous emissions missing.'
-             CALL message( 'salsa_mod: salsa_set_source', 'SA0041',            &
-                           1, 2, 0, 6, 0 )
-          ENDIF       
-!
-!--       Get number of emission categories  
-          CALL netcdf_data_input_get_dimension_length( id_fchem, ncat, "ncat" )       
-!
-!--       Inquire the unit of gaseous fluxes
-          CALL get_attribute( id_fchem, 'units', unitg, .FALSE.,               &
-                              "emission_values")       
-!
-!--       Inquire the fill value 
-          CALL get_attribute( id_fchem, '_FillValue', fillval, .FALSE.,        &
-                              "emission_values" )
-!        
-!--       Read surface emission data (x,y) PE-wise   
-          ALLOCATE( dum_var_4d(ng_file,ncat,nys:nyn,nxl:nxr) )      
-          CALL get_variable( id_fchem, 'emission_values', dum_var_4d, nxl, nxr,&
-                             nys, nyn, 0, ncat-1, 0, ng_file-1 )
-          DO  g = 1, ngast
-             ALLOCATE( salsa_gas(g)%source(ncat,nys:nyn,nxl:nxr) )
-             salsa_gas(g)%source = 0.0_wp
-             salsa_gas(g)%source = salsa_gas(g)%source + dum_var_4d(g,:,:,:)
-          ENDDO                   
-!   
-!--       Set surface fluxes of gaseous compounds on horizontal surfaces.
-!--       Set fluxes only for either default, land or urban surface.
-          IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-             CALL set_gas_flux( surf_def_h(0), ncat, unitg  )
-          ELSE
-             CALL set_gas_flux( surf_lsm_h, ncat, unitg  )
-             CALL set_gas_flux( surf_usm_h, ncat, unitg  )
+          IF ( init )  THEN
+!
+!--          Check existence of PIDS_SALSA file
+             INQUIRE( FILE = input_file_salsa // TRIM( coupling_char ), EXIST = netcdf_extend )
+             IF ( .NOT. netcdf_extend )  THEN
+                message_string = 'Input file '// TRIM( input_file_salsa ) //  TRIM( coupling_char )&
+                                 // ' missing!'
+                CALL message( 'salsa_emission_setup', 'PA0629', 1, 2, 0, 6, 0 )
+             ENDIF
+!
+!--          Open file in read-only mode
+             CALL open_read_file( input_file_salsa // TRIM( coupling_char ), id_salsa )
+!
+!--          Read the index and name of chemical components
+             CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%ncc,         &
+                                                          'composition_index' )
+             ALLOCATE( aero_emission_att%cc_index(1:aero_emission_att%ncc) )
+             CALL get_variable( id_salsa, 'composition_index', aero_emission_att%cc_index )
+             CALL get_variable( id_salsa, 'composition_name', aero_emission_att%cc_name,           &
+                                aero_emission_att%ncc )
+!
+!--          Find the corresponding chemical components in the model
+             aero_emission_att%cc_input_to_model = 0
+             DO  ic = 1, aero_emission_att%ncc
+                in_name = aero_emission_att%cc_name(ic)
+                SELECT CASE ( TRIM( in_name ) )
+                   CASE ( 'H2SO4', 'h2so4', 'SO4', 'so4' )
+                      aero_emission_att%cc_input_to_model(1) = ic
+                   CASE ( 'OC', 'oc', 'organics' )
+                      aero_emission_att%cc_input_to_model(2) = ic
+                   CASE ( 'BC', 'bc' )
+                      aero_emission_att%cc_input_to_model(3) = ic
+                   CASE ( 'DU', 'du' )
+                      aero_emission_att%cc_input_to_model(4) = ic
+                   CASE ( 'SS', 'ss' )
+                      aero_emission_att%cc_input_to_model(5) = ic
+                   CASE ( 'HNO3', 'hno3', 'NO', 'no' )
+                      aero_emission_att%cc_input_to_model(6) = ic
+                   CASE ( 'NH3', 'nh3', 'NH', 'nh' )
+                      aero_emission_att%cc_input_to_model(7) = ic
+                END SELECT
+
+             ENDDO
+
+             IF ( SUM( aero_emission_att%cc_input_to_model ) == 0 )  THEN
+                message_string = 'None of the aerosol chemical components in ' // TRIM(            &
+                                 input_file_salsa ) // ' correspond to the ones applied in SALSA.'
+                CALL message( 'salsa_emission_setup', 'PA0630', 1, 2, 0, 6, 0 )
+             ENDIF
+!
+!--          Inquire the fill value
+             CALL get_attribute( id_salsa, '_FillValue', aero_emission%fill, .FALSE.,              &
+                                 'aerosol_emission_values' )
+!
+!--          Inquire units of emissions
+             CALL get_attribute( id_salsa, 'units', aero_emission_att%units, .FALSE.,              &
+                                 'aerosol_emission_values' )
+!
+!--          Inquire the level of detail (lod)
+             CALL get_attribute( id_salsa, 'lod', aero_emission_att%lod, .FALSE.,                  &
+                                 'aerosol_emission_values' )
+!
+!--          Variable names
+             CALL inquire_num_variables( id_salsa, aero_emission_att%num_vars )
+             ALLOCATE( aero_emission_att%var_names(1:aero_emission_att%num_vars) )
+             CALL inquire_variable_names( id_salsa, aero_emission_att%var_names )
+
+!
+!--          Read different emission information depending on the level of detail of emissions:
+
+!
+!--          Default mode:
+             IF ( aero_emission_att%lod == 1 )  THEN
+!
+!--             Unit conversion factor: convert to SI units (kg/m2/s)
+                IF ( aero_emission_att%units == 'kg/m2/yr' )  THEN
+                   aero_emission_att%conversion_factor = 1.0_wp / 3600.0_wp
+                ELSEIF ( aero_emission_att%units == 'g/m2/yr' )  THEN
+                   aero_emission_att%conversion_factor = 0.001_wp / 3600.0_wp
+                ELSE
+                   message_string = 'unknown unit for aerosol emissions: ' //                      &
+                                    TRIM( aero_emission_att%units ) // ' (lod1)'
+                   CALL message( 'salsa_emission_setup','PA0631', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Get number of emission categories and allocate emission arrays
+                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%ncat,     &
+                                                             'ncat' )
+                ALLOCATE( aero_emission_att%cat_index(1:aero_emission_att%ncat),                   &
+                          aero_emission_att%rho(1:aero_emission_att%ncat),                         &
+                          aero_emission_att%time_factor(1:aero_emission_att%ncat) )
+!
+!--             Get emission category names and indices
+                CALL get_variable( id_salsa, 'emission_category_name', aero_emission_att%cat_name, &
+                                   aero_emission_att%ncat)
+                CALL get_variable( id_salsa, 'emission_category_index', aero_emission_att%cat_index )
+!
+!--             Find corresponding emission categories
+                DO  in = 1, aero_emission_att%ncat
+                   in_name = aero_emission_att%cat_name(in)
+                   DO  ss = 1, def_modes%ndc
+                      mod_name = def_modes%cat_name_table(ss)
+                      IF ( TRIM( in_name(1:4) ) == TRIM( mod_name(1:4 ) ) )  THEN
+                         def_modes%cat_input_to_model(ss) = in
+                      ENDIF
+                   ENDDO
+                ENDDO
+
+                IF ( SUM( def_modes%cat_input_to_model ) == 0 )  THEN
+                   message_string = 'None of the emission categories in ' //  TRIM(                &
+                                    input_file_salsa ) // ' match with the ones in the model.'
+                   CALL message( 'salsa_emission_setup', 'PA0632', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Emission time factors: Find check whether emission time factors are given for each
+!--             hour of year OR based on month, day and hour
+!
+!--             For each hour of year:
+                IF ( check_existence( aero_emission_att%var_names, 'nhoursyear' ) )  THEN
+                   CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nhoursyear,&
+                                                                'nhoursyear' )
+                   ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
+                                                   1:aero_emission_att%nhoursyear) )
+                   CALL get_variable( id_salsa, 'emission_time_factors', aero_emission_att%etf,    &
+                                    0, aero_emission_att%nhoursyear-1, 0, aero_emission_att%ncat-1 )
+!
+!--             Based on the month, day and hour:
+                ELSEIF ( check_existence( aero_emission_att%var_names, 'nmonthdayhour' ) )  THEN
+                   CALL netcdf_data_input_get_dimension_length( id_salsa,                          &
+                                                                aero_emission_att%nmonthdayhour,   &
+                                                                'nmonthdayhour' )
+                   ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
+                                                   1:aero_emission_att%nmonthdayhour) )
+                   CALL get_variable( id_salsa, 'emission_time_factors', aero_emission_att%etf,    &
+                                 0, aero_emission_att%nmonthdayhour-1, 0, aero_emission_att%ncat-1 )
+                ELSE
+                   message_string = 'emission_time_factors should be given for each nhoursyear ' //&
+                                    'OR nmonthdayhour'
+                   CALL message( 'salsa_emission_setup','PA0633', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Next emission update
+                next_aero_emission_update = MOD( time_utc_init, 3600.0_wp ) - 3600.0_wp
+!
+!--             Get chemical composition (i.e. mass fraction of different species) in aerosols
+                ALLOCATE( aero_emission%def_mass_fracs(1:aero_emission_att%ncat,                   &
+                                                       1:aero_emission_att%ncc) )
+                aero_emission%def_mass_fracs = 0.0_wp
+                CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%def_mass_fracs,  &
+                                   0, aero_emission_att%ncc-1, 0, aero_emission_att%ncat-1 )
+!
+!--             If the chemical component is not activated, set its mass fraction to 0 to avoid
+!--             inbalance between number and mass flux
+                cc_i2m = aero_emission_att%cc_input_to_model
+                IF ( index_so4 < 0  .AND.  cc_i2m(1) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(1)) = 0.0_wp
+                IF ( index_oc  < 0  .AND.  cc_i2m(2) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(2)) = 0.0_wp
+                IF ( index_bc  < 0  .AND.  cc_i2m(3) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(3)) = 0.0_wp
+                IF ( index_du  < 0  .AND.  cc_i2m(4) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(4)) = 0.0_wp
+                IF ( index_ss  < 0  .AND.  cc_i2m(5) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(5)) = 0.0_wp
+                IF ( index_no  < 0  .AND.  cc_i2m(6) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(6)) = 0.0_wp
+                IF ( index_nh  < 0  .AND.  cc_i2m(7) /= 0 )                                        &
+                                                  aero_emission%def_mass_fracs(:,cc_i2m(7)) = 0.0_wp
+!
+!--             Then normalise the mass fraction so that SUM = 1
+                DO  in = 1, aero_emission_att%ncat
+                   aero_emission%def_mass_fracs(in,:) = aero_emission%def_mass_fracs(in,:) /       &
+                                                       SUM( aero_emission%def_mass_fracs(in,:) )
+                ENDDO
+!
+!--             Calculate average mass density (kg/m3)
+                aero_emission_att%rho = 0.0_wp
+
+                IF ( cc_i2m(1) /= 0 )  aero_emission_att%rho = aero_emission_att%rho +  arhoh2so4 *&
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(1))
+                IF ( cc_i2m(2) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhooc *    &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(2))
+                IF ( cc_i2m(3) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhobc *    &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(3))
+                IF ( cc_i2m(4) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhodu *    &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(4))
+                IF ( cc_i2m(5) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhoss *    &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(5))
+                IF ( cc_i2m(6) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhohno3 *  &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(6))
+                IF ( cc_i2m(7) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhonh3 *   &
+                                                           aero_emission%def_mass_fracs(:,cc_i2m(7))
+!
+!--             Allocate and read surface emission data (in total PM)
+                ALLOCATE( aero_emission%def_data(nys:nyn,nxl:nxr,1:aero_emission_att%ncat) )
+                CALL get_variable( id_salsa, 'aerosol_emission_values', aero_emission%def_data,    &
+                                   0, aero_emission_att%ncat-1, nxl, nxr, nys, nyn )
+
+!
+!--          Pre-processed mode
+             ELSEIF ( aero_emission_att%lod == 2 )  THEN
+!
+!--             Unit conversion factor: convert to SI units (#/m2/s)
+                IF ( aero_emission_att%units == '#/m2/s' )  THEN
+                   aero_emission_att%conversion_factor = 1.0_wp
+                ELSE
+                   message_string = 'unknown unit for aerosol emissions: ' //                      &
+                                    TRIM( aero_emission_att%units )
+                   CALL message( 'salsa_emission_setup','PA0634', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Number of aerosol size bins in the emission data
+                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nbins,    &
+                                                             'Dmid' )
+                IF ( aero_emission_att%nbins /= nbins_aerosol )  THEN
+                   message_string = 'The number of size bins in aerosol input data does not ' //   &
+                                    'correspond to the model set-up'
+                   CALL message( 'salsa_emission_setup','PA0635', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Number of time steps in the emission data
+                CALL netcdf_data_input_get_dimension_length( id_salsa, aero_emission_att%nt, 'time')
+!
+!--             Allocate bin diameters, time and mass fraction array
+                ALLOCATE( aero_emission_att%dmid(1:nbins_aerosol),                                 &
+                          aero_emission_att%time(1:aero_emission_att%nt),                          &
+                          aero_emission%preproc_mass_fracs(1:aero_emission_att%ncc) )
+!
+!--             Read mean diameters
+                CALL get_variable( id_salsa, 'Dmid', aero_emission_att%dmid )
+!
+!--             Check whether the sectional representation of the aerosol size distribution conform
+!--             to the one applied in the model
+                IF ( ANY( ABS( ( aero(1:nbins_aerosol)%dmid - aero_emission_att%dmid ) /           &
+                               aero(1:nbins_aerosol)%dmid ) > 0.1_wp )  )  THEN
+                   message_string = 'Mean diameters of size bins in ' // TRIM( input_file_salsa )  &
+                                    // ' do not match with the ones in the model.'
+                   CALL message( 'salsa_emission_setup','PA0636', 1, 2, 0, 6, 0 )
+                ENDIF
+!
+!--             Read time stamps:
+                CALL get_variable( id_salsa, 'time', aero_emission_att%time )
+!
+!--             Read emission mass fractions
+                CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%preproc_mass_fracs )
+!
+!--             If the chemical component is not activated, set its mass fraction to 0
+                cc_i2m = aero_emission_att%cc_input_to_model
+                IF ( index_so4 < 0  .AND.  cc_i2m(1) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(1)) = 0.0_wp
+                IF ( index_oc  < 0  .AND.  cc_i2m(2) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(2)) = 0.0_wp
+                IF ( index_bc  < 0  .AND.  cc_i2m(3) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(3)) = 0.0_wp
+                IF ( index_du  < 0  .AND.  cc_i2m(4) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(4)) = 0.0_wp
+                IF ( index_ss  < 0  .AND.  cc_i2m(5) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(5)) = 0.0_wp
+                IF ( index_no  < 0  .AND.  cc_i2m(6) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(6)) = 0.0_wp
+                IF ( index_nh  < 0  .AND.  cc_i2m(7) /= 0 )                                        &
+                   aero_emission%preproc_mass_fracs(cc_i2m(7)) = 0.0_wp
+!
+!--             Then normalise the mass fraction so that SUM = 1
+                aero_emission%preproc_mass_fracs = aero_emission%preproc_mass_fracs /              &
+                                                   SUM( aero_emission%preproc_mass_fracs )
+
+             ELSE
+                message_string = 'Unknown lod for aerosol_emission_values.'
+                CALL message( 'salsa_emission','PA0637', 1, 2, 0, 6, 0 )
+             ENDIF
+
+          ENDIF  ! init
+!
+!--       Define and set current emission values:
+!
+!--       Default type emissions (aerosol emission given as total mass emission per year):
+          IF ( aero_emission_att%lod == 1 )  THEN
+!
+!--          Emission time factors for each emission category at current time step
+             IF ( aero_emission_att%nhoursyear > aero_emission_att%nmonthdayhour )  THEN
+!
+!--             Get the index of the current hour
+                CALL time_default_indices( month_of_year, day_of_month, hour_of_day, index_hh )
+                aero_emission_att%time_factor = aero_emission_att%etf(:,index_hh)
+
+             ELSEIF ( aero_emission_att%nhoursyear < aero_emission_att%nmonthdayhour )  THEN
+!
+!--             Get the index of current hour (index_hh) (TODO: Now "workday" is always assumed.
+!--             Needs to be calculated.)
+                CALL time_default_indices( daytype, month_of_year, day_of_month, hour_of_day,      &
+                                           index_mm, index_dd, index_hh )
+                aero_emission_att%time_factor = aero_emission_att%etf(:,index_mm) *                &
+                                                aero_emission_att%etf(:,index_dd) *                &
+                                                aero_emission_att%etf(:,index_hh)
+             ENDIF
+
+!
+!--          Create a sectional number size distribution for emissions
+             ALLOCATE( nsect_emission(1:nbins_aerosol),source_array(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+             DO  in = 1, aero_emission_att%ncat
+
+                inn = def_modes%cat_input_to_model(in)
+!
+!--             Calculate the number concentration (1/m3) of a log-normal size distribution 
+!--             following Jacobson (2005): Eq 13.25.
+                def_modes%ntot_table = 6.0_wp * def_modes%pm_frac_table(:,inn) / ( pi *            &
+                                       ( def_modes%dpg_table )**3 *  EXP( 4.5_wp *                 &
+                                       LOG( def_modes%sigmag_table )**2 ) )
+!
+!--             Sectional size distibution (1/m3) from a log-normal one
+                CALL size_distribution( def_modes%ntot_table, def_modes%dpg_table,                 &
+                                        def_modes%sigmag_table, nsect_emission )
+
+                source_array = 0.0_wp
+                DO  ib = 1, nbins_aerosol
+                   source_array(:,:,ib) = aero_emission%def_data(:,:,in) *                         &
+                                          aero_emission_att%conversion_factor /                    &
+                                          aero_emission_att%rho(in) * nsect_emission(ib) *         &
+                                          aero_emission_att%time_factor(in)
+                ENDDO
+!
+!--             Set surface fluxes of aerosol number and mass on horizontal surfaces. Set fluxes
+!--             only for either default, land or urban surface.
+                IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
+                   CALL set_flux( surf_def_h(0), aero_emission_att%cc_input_to_model,              &
+                                  aero_emission%def_mass_fracs(in,:), source_array )
+                ELSE
+                   CALL set_flux( surf_usm_h, aero_emission_att%cc_input_to_model,                 &
+                                  aero_emission%def_mass_fracs(in,:), source_array )
+                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_input_to_model,                 &
+                                  aero_emission%def_mass_fracs(in,:), source_array )
+                ENDIF
+             ENDDO
+!
+!--          The next emission update is again after one hour
+             next_aero_emission_update = next_aero_emission_update + 3600.0_wp
+
+
+             DEALLOCATE( source_array )
+!
+!--       Pre-processed:
+          ELSEIF ( aero_emission_att%lod == 2 )  THEN
+!
+!--          Obtain time index for current input starting at 0.
+!--          @todo: At the moment emission data and simulated time correspond to each other.
+             aero_emission_att%tind = MINLOC( ABS( aero_emission_att%time -                        &
+                                                   time_since_reference_point ), DIM = 1 ) - 1
+!
+!--          Allocate the data input array always before reading in the data and deallocate after
+             ALLOCATE( aero_emission%preproc_data(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+!
+!--          Read in the next time step
+             CALL get_variable( id_salsa, 'aerosol_emission_values', aero_emission%preproc_data,&
+                                aero_emission_att%tind, 0, nbins_aerosol-1, nxl, nxr, nys, nyn )
+!
+!--          Set surface fluxes of aerosol number and mass on horizontal surfaces. Set fluxes only
+!--          for either default, land and urban surface.
+             IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
+                CALL set_flux( surf_def_h(0), aero_emission_att%cc_input_to_model,                 &
+                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
+             ELSE
+                CALL set_flux( surf_usm_h, aero_emission_att%cc_input_to_model,                    &
+                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
+                CALL set_flux( surf_lsm_h, aero_emission_att%cc_input_to_model,                    &
+                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
+             ENDIF
+!
+!--          Determine the next emission update
+             next_aero_emission_update = aero_emission_att%time(aero_emission_att%tind+2)
+
+             DEALLOCATE( aero_emission%preproc_data )
+
           ENDIF
-          
-          DEALLOCATE( dum_var_4d )
-          DO  g = 1, ngast
-             DEALLOCATE( salsa_gas(g)%source )
-          ENDDO
-       ELSE
-          message_string = 'Input file PIDS_CHEM needs to have lod = 2 when '//&
-                           'SALSA is applied but not the chemistry module!'
-          CALL message( 'salsa_mod: salsa_set_source', 'SA0039', 1, 2, 0, 6, 0 )    
-       ENDIF             
-    ENDIF 
-!       
-!-- Read sources from PIDS_SALSA        
-    INQUIRE( FILE='PIDS_SALSA' // TRIM( coupling_char ), EXIST=netcdf_extend )
-    IF ( .NOT. netcdf_extend )  THEN
-       message_string = 'Input file '// TRIM( 'PIDS_SALSA' ) //                &
-                         TRIM( coupling_char ) // ' for SALSA missing!'
-       CALL message( 'salsa_mod: salsa_set_source', 'SA0034', 1, 2, 0, 6, 0 )                
-    ENDIF   ! netcdf_extend      
-!
-!-- Open file in read-only mode     
-    CALL open_read_file( 'PIDS_SALSA' // TRIM( coupling_char ), id_faero )
-!
-!-- Get number of emission categories and their indices       
-    CALL netcdf_data_input_get_dimension_length( id_faero, ncat, "ncat" ) 
-!
-!-- Get emission category indices
-    ALLOCATE( eci(1:ncat) )
-    CALL get_variable( id_faero, 'emission_category_index', eci ) 
-!
-!-- Inquire the level of detail (lod)
-    CALL get_attribute( id_faero, 'lod', lod_aero, .FALSE.,                    &
-                        "aerosol_emission_values" ) 
-                            
-    IF ( lod_aero < 3  .AND.  ibc_salsa_b  == 0 ) THEN
-       message_string = 'lod1/2 for aerosol emissions requires '//             &
-                        'bc_salsa_b = "Neumann"'
-       CALL message( 'salsa_mod: salsa_set_source','SA0025', 1, 2, 0, 6, 0 )
-    ENDIF
-!
-!-- Inquire the fill value 
-    CALL get_attribute( id_faero, '_FillValue', fillval, .FALSE.,              &
-                        "aerosol_emission_values" )
-!
-!-- Aerosol chemical composition:
-    ALLOCATE( emission_mass_fracs(1:ncat,1:maxspec) )
-    emission_mass_fracs = 0.0_wp
-!-- Chemical composition: 1: H2SO4 (sulphuric acid), 2: OC (organic carbon), 
-!--                       3: BC (black carbon), 4: DU (dust),  
-!--                       5: SS (sea salt),     6: HNO3 (nitric acid), 
-!--                       7: NH3 (ammonia)
-    DO  n = 1, ncat
-       IF  ( lod_aero < 2 )  THEN
-          emission_mass_fracs(n,:) = mass_fraction_table(:,n)
-       ELSE
-          CALL get_variable( id_faero, "emission_mass_fracs",                  &
-                             emission_mass_fracs(n,:) )
-       ENDIF 
-!
-!--    If the chemical component is not activated, set its mass fraction to 0
-!--    to avoid inbalance between number and mass flux
-       IF ( iso4 < 0 )  emission_mass_fracs(n,1) = 0.0_wp
-       IF ( ioc  < 0 )  emission_mass_fracs(n,2) = 0.0_wp
-       IF ( ibc  < 0 )  emission_mass_fracs(n,3) = 0.0_wp
-       IF ( idu  < 0 )  emission_mass_fracs(n,4) = 0.0_wp
-       IF ( iss  < 0 )  emission_mass_fracs(n,5) = 0.0_wp
-       IF ( ino  < 0 )  emission_mass_fracs(n,6) = 0.0_wp
-       IF ( inh  < 0 )  emission_mass_fracs(n,7) = 0.0_wp
-!--    Then normalise the mass fraction so that SUM = 1                   
-       emission_mass_fracs(n,:) = emission_mass_fracs(n,:) /                   &
-                                  SUM( emission_mass_fracs(n,:) )
-    ENDDO
-    
-    IF ( lod_aero > 1 )  THEN
-!
-!--    Aerosol geometric mean diameter  
-       CALL netcdf_data_input_get_dimension_length( id_faero, nb_file, 'Dmid' )     
-       IF ( nb_file /= nbins )  THEN
-          message_string = 'The number of size bins in aerosol input data '//  &
-                           'does not correspond to the model set-up'
-          CALL message( 'salsa_mod: salsa_set_source','SA0040', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
-
-    IF ( lod_aero < 3 )  THEN
-       CALL location_message( '    salsa_set_source: No time dependency for '//&
-                             'aerosol emissions. Use aerosol_emission_values'//&
-                             ' directly.', .TRUE. )
-!
-!--    Allocate source arrays 
-       DO  b = 1, nbins
-          ALLOCATE( aerosol_number(b)%source(1:ncat,nys:nyn,nxl:nxr) )
-          aerosol_number(b)%source = 0.0_wp
-       ENDDO 
-       DO  c = 1, ncc_tot*nbins
-          ALLOCATE( aerosol_mass(c)%source(1:ncat,nys:nyn,nxl:nxr) )
-          aerosol_mass(c)%source = 0.0_wp
-       ENDDO
-       
-       IF ( lod_aero == 1 )  THEN
-          DO  n = 1, ncat
-             avg_density(n) = emission_mass_fracs(n,1) * arhoh2so4 +           &
-                              emission_mass_fracs(n,2) * arhooc +              &
-                              emission_mass_fracs(n,3) * arhobc +              &
-                              emission_mass_fracs(n,4) * arhodu +              &
-                              emission_mass_fracs(n,5) * arhoss +              &
-                              emission_mass_fracs(n,6) * arhohno3 +            &
-                              emission_mass_fracs(n,7) * arhonh3
-          ENDDO    
-!
-!--       Emission unit
-          CALL get_attribute( id_faero, 'units', unita, .FALSE.,               &
-                              "aerosol_emission_values")
-          conversion_factor = 1.0_wp
-          IF  ( unita == 'kg/m2/yr' )  THEN
-             conversion_factor = 3.170979e-8_wp / avg_density
-          ELSEIF  ( unita == 'g/m2/yr' )  THEN
-             conversion_factor = 3.170979e-8_wp * 1.0E-3_wp / avg_density
-          ELSEIF  ( unita == 'kg/m2/s' )  THEN
-             conversion_factor = 1.0_wp / avg_density
-          ELSEIF  ( unita == 'g/m2/s' )  THEN
-             conversion_factor = 1.0E-3_wp / avg_density
-          ELSE 
-             message_string = 'unknown unit for aerosol emissions: '           &
-                              // TRIM( unita ) // ' (lod1)'
-             CALL message( 'salsa_mod: salsa_set_source','SA0035',             &
-                           1, 2, 0, 6, 0 )
-          ENDIF
-!        
-!--       Read surface emission data (x,y) PE-wise  
-          ALLOCATE( pm_emission(ncat,nys:nyn,nxl:nxr) )
-          CALL get_variable( id_faero, 'aerosol_emission_values', pm_emission, &
-                             nxl, nxr, nys, nyn, 0, ncat-1 )
-          DO  ni = 1, SIZE( eci )
-             n = eci(ni)
-!
-!--          Calculate the number concentration of a log-normal size 
-!--          distribution following Jacobson (2005): Eq 13.25.
-             ntot_table = 6.0_wp * PMfrac_table(:,n) / ( pi * dpg_table**3 *   &
-                          EXP( 4.5_wp * LOG( sigmag_table )**2 ) ) * 1.0E+12_wp
-!                          
-!--          Sectional size distibution from a log-normal one                          
-             CALL size_distribution( ntot_table, dpg_table, sigmag_table,      &
-                                     nsect_emission )
-             DO  b = 1, nbins
-                aerosol_number(b)%source(ni,:,:) =                             &
-                                    aerosol_number(b)%source(ni,:,:) +         &
-                                    pm_emission(ni,:,:) * conversion_factor(n) &
-                                    * nsect_emission(b) 
-             ENDDO
-          ENDDO
-       ELSEIF ( lod_aero == 2 )  THEN             
-!        
-!--       Read surface emission data (x,y) PE-wise   
-          ALLOCATE( dum_var_4d(nb_file,ncat,nys:nyn,nxl:nxr) )
-          CALL get_variable( id_faero, 'aerosol_emission_values', dum_var_4d,  &
-                             nxl, nxr, nys, nyn, 0, ncat-1, 0, nb_file-1 )
-          DO  b = 1, nbins
-             aerosol_number(b)%source = dum_var_4d(b,:,:,:)
-          ENDDO
-          DEALLOCATE( dum_var_4d )
-       ENDIF
-!   
-!--    Set surface fluxes of aerosol number and mass on horizontal surfaces.
-!--    Set fluxes only for either default, land or urban surface.
-       IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-          CALL set_flux( surf_def_h(0), ncat )
-       ELSE
-          CALL set_flux( surf_usm_h, ncat )
-          CALL set_flux( surf_lsm_h, ncat )
-       ENDIF
-          
-    ELSEIF ( lod_aero == 3 )  THEN
-!
-!--    Inquire aerosol emission rate per bin (#/(m3s))
-       nc_stat = NF90_INQ_VARID( id_faero, "aerosol_emission_values", id_sa )
-  
-!
-!--    Emission time step
-       CALL netcdf_data_input_get_dimension_length( id_faero, n_dt,            &
-                                                    'dt_emission' ) 
-       IF ( n_dt > 1 )  THEN
-          CALL location_message( '    salsa_set_source: hourly emission data'//&
-                                 ' provided but currently the value of the '// &
-                                 ' first hour is applied.', .TRUE. )
-       ENDIF
-!
-!--    Allocate source arrays 
-       DO  b = 1, nbins
-          ALLOCATE( aerosol_number(b)%source(nzb:nzt+1,nys:nyn,nxl:nxr) )
-          aerosol_number(b)%source = 0.0_wp
-       ENDDO
-       DO  c = 1, ncc_tot*nbins
-          ALLOCATE( aerosol_mass(c)%source(nzb:nzt+1,nys:nyn,nxl:nxr) )
-          aerosol_mass(c)%source = 0.0_wp
-       ENDDO
-!
-!--    Get dimension of z-axis:      
-       CALL netcdf_data_input_get_dimension_length( id_faero, nz_file, 'z' )
-!        
-!--    Read surface emission data (x,y) PE-wise             
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = 0, nz_file-1
-!
-!--             Predetermine flag to mask topography                                 
-                flag = MERGE( 1.0_wp, 0.0_wp, BTEST(wall_flags_0(k,j,i), 0 ))
-!                                             
-!--             No sources inside buildings !                                          
-                IF ( flag == 0.0_wp )  CYCLE                          
-! 
-!--             Read volume source:
-                nc_stat = NF90_GET_VAR( id_faero, id_sa, source_ijka,          &
-                                        start = (/ i+1, j+1, k+1, 1, 1 /),     &
-                                        count = (/ 1, 1, 1, 1, nb_file /) )
-                IF ( nc_stat /= NF90_NOERR )  THEN
-                   message_string = 'error in aerosol emissions: lod3'
-                   CALL message( 'salsa_mod: salsa_set_source','SA0038', 1, 2, &
-                                 0, 6, 0 )
+
+#else
+          message_string = 'salsa_emission_mode = "read_from_file", but preprocessor directive ' //&
+                           ' __netcdf is not used in compiling!'
+          CALL message( 'salsa_emission_setup', 'PA0638', 1, 2, 0, 6, 0 )
+
+#endif
+       CASE DEFAULT
+          message_string = 'unknown salsa_emission_mode: ' // TRIM( salsa_emission_mode )
+          CALL message( 'salsa_emission_setup', 'PA0639', 1, 2, 0, 6, 0 )
+
+    END SELECT
+
+    CONTAINS
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sets the aerosol flux to aerosol arrays in 2a and 2b.
+!------------------------------------------------------------------------------!
+    SUBROUTINE set_flux( surface, cc_i_mod, mass_fracs, source_array )
+
+       USE arrays_3d,                                                                              &
+           ONLY:  rho_air_zw
+
+       USE surface_mod,                                                                            &
+           ONLY:  surf_type
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i   !< loop index
+       INTEGER(iwp) ::  ib  !< loop index
+       INTEGER(iwp) ::  ic  !< loop index
+       INTEGER(iwp) ::  j   !< loop index
+       INTEGER(iwp) ::  k   !< loop index
+       INTEGER(iwp) ::  m   !< running index for surface elements
+
+       INTEGER(iwp), DIMENSION(:) ::  cc_i_mod   !< index of chemical component in the input data
+
+       REAL(wp) ::  so4_oc  !< mass fraction between SO4 and OC in 1a
+
+       REAL(wp), DIMENSION(:), INTENT(in) ::  mass_fracs  !< mass fractions of chemical components
+
+       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,1:nbins_aerosol), INTENT(inout) ::  source_array  !<
+
+       TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
+
+       so4_oc = 0.0_wp
+
+       DO  m = 1, surface%ns
+!
+!--       Get indices of respective grid point
+          i = surface%i(m)
+          j = surface%j(m)
+          k = surface%k(m)
+
+          DO  ib = 1, nbins_aerosol
+             IF ( source_array(j,i,ib) < nclim )  THEN
+                source_array(j,i,ib) = 0.0_wp
+             ENDIF
+!
+!--          Set mass fluxes.  First bins include only SO4 and/or OC.
+             IF ( ib <= end_subrange_1a )  THEN
+!
+!--             Both sulphate and organic carbon
+                IF ( index_so4 > 0  .AND.  index_oc > 0 )  THEN
+
+                   ic = ( index_so4 - 1 ) * nbins_aerosol + ib
+                   so4_oc = mass_fracs(cc_i_mod(1)) / ( mass_fracs(cc_i_mod(1)) +                  &
+                                                        mass_fracs(cc_i_mod(2)) )
+                   surface%amsws(m,ic) = surface%amsws(m,ic) + so4_oc * source_array(j,i,ib)       &
+                                         * api6 * aero(ib)%dmid**3 * arhoh2so4 * rho_air_zw(k-1)
+                   aerosol_mass(ic)%source(j,i) = aerosol_mass(ic)%source(j,i) + surface%amsws(m,ic)
+
+                   ic = ( index_oc - 1 ) * nbins_aerosol + ib
+                   surface%amsws(m,ic) = surface%amsws(m,ic) + ( 1-so4_oc ) * source_array(j,i,ib) &
+                                         * api6 * aero(ib)%dmid**3 * arhooc * rho_air_zw(k-1)
+                   aerosol_mass(ic)%source(j,i) = aerosol_mass(ic)%source(j,i) + surface%amsws(m,ic)
+!
+!--             Only sulphates
+                ELSEIF ( index_so4 > 0  .AND.  index_oc < 0 )  THEN
+                   ic = ( index_so4 - 1 ) * nbins_aerosol + ib
+                   surface%amsws(m,ic) = surface%amsws(m,ic) + source_array(j,i,ib) * api6 *       &
+                                         aero(ib)%dmid**3 * arhoh2so4 * rho_air_zw(k-1)
+                   aerosol_mass(ic)%source(j,i) = aerosol_mass(ic)%source(j,i) + surface%amsws(m,ic)
+!
+!--             Only organic carbon
+                ELSEIF ( index_so4 < 0  .AND.  index_oc > 0 )  THEN
+                   ic = ( index_oc - 1 ) * nbins_aerosol + ib
+                   surface%amsws(m,ic) = surface%amsws(m,ic) + source_array(j,i,ib) * api6 *       &
+                                         aero(ib)%dmid**3 * arhooc * rho_air_zw(k-1)
+                   aerosol_mass(ic)%source(j,i) = aerosol_mass(ic)%source(j,i) + surface%amsws(m,ic)
                 ENDIF
-!       
-!--             Set mass fluxes.  First bins include only SO4 and/or OC. Call 
-!--             subroutine set_mass_source for larger bins.                            
-!
-!--             Sulphate and organic carbon
-                IF ( iso4 > 0  .AND.  ioc > 0 ) THEN                 
-!--                First sulphate:                     
-                   ss = ( iso4 - 1 ) * nbins + in1a   ! start
-                   ee = ( iso4 - 1 ) * nbins + fn1a   ! end
-                   b = in1a            
-                   DO  c = ss, ee
-                      IF ( source_ijka(b) /= fillval )                         &
-                      aerosol_mass(c)%source(k,j,i) =                          &
-                         aerosol_mass(c)%source(k,j,i) +                       &
-                         emission_mass_fracs(1,1) / ( emission_mass_fracs(1,1) &
-                         + emission_mass_fracs(1,2) ) * source_ijka(b) *       &
-                         aero(b)%core * arhoh2so4 
-                      b = b+1
-                   ENDDO                  
-!--                Then organic carbon:                      
-                   ss = ( ioc - 1 ) * nbins + in1a   ! start
-                   ee = ( ioc - 1 ) * nbins + fn1a   ! end 
-                   b = in1a
-                   DO  c = ss, ee 
-                      IF ( source_ijka(b) /= fillval )                         &
-                      aerosol_mass(c)%source(k,j,i) =                          &
-                         aerosol_mass(c)%source(k,j,i) +                       &
-                         emission_mass_fracs(1,2) / ( emission_mass_fracs(1,1) &
-                         + emission_mass_fracs(1,2) ) * source_ijka(b) *       &
-                         aero(b)%core * arhooc 
-                      b = b+1
-                   ENDDO
-                   
-                   CALL set_mass_source( k, j, i, iso4,                        &
-                                        emission_mass_fracs(1,1), arhoh2so4,   &
-                                        source_ijka, fillval )
-                   CALL set_mass_source( k, j, i, ioc, emission_mass_fracs(1,2),&
-                                         arhooc, source_ijka, fillval )                      
-!--             Only sulphate:                                             
-                ELSEIF ( iso4 > 0  .AND.  ioc < 0 ) THEN                    
-                   ss = ( iso4 - 1 ) * nbins + in1a   ! start
-                   ee = ( iso4 - 1 ) * nbins + fn1a   ! end
-                   b = in1a            
-                   DO  c = ss, ee
-                      IF ( source_ijka(b) /= fillval )                         &
-                      aerosol_mass(c)%source(k,j,i) =                          &
-                         aerosol_mass(c)%source(k,j,i) + source_ijka(b) *      &
-                         aero(b)%core * arhoh2so4 
-                      b = b+1
-                   ENDDO 
-                   CALL set_mass_source( k, j, i, iso4,                        &
-                                        emission_mass_fracs(1,1), arhoh2so4,   &
-                                        source_ijka, fillval )    
-!--             Only organic carbon:                                            
-                ELSEIF ( iso4 < 0  .AND.  ioc > 0 ) THEN                    
-                   ss = ( ioc - 1 ) * nbins + in1a   ! start
-                   ee = ( ioc - 1 ) * nbins + fn1a   ! end 
-                   b = in1a
-                   DO  c = ss, ee 
-                      IF ( source_ijka(b) /= fillval )                         &
-                      aerosol_mass(c)%source(k,j,i) =                          &
-                         aerosol_mass(c)%source(k,j,i) + source_ijka(b)  *     &
-                         aero(b)%core * arhooc 
-                      b = b+1
-                   ENDDO 
-                   CALL set_mass_source( k, j, i, ioc, emission_mass_fracs(1,2),&
-                                         arhooc,  source_ijka, fillval )                                    
+
+             ELSE
+!
+!--             Sulphate
+                IF ( index_so4 > 0 )  THEN
+                   ic = cc_i_mod(1)
+                   CALL set_mass_flux( surface, m, ib, index_so4, mass_fracs(ic), arhoh2so4,       &
+                                       source_array(j,i,ib) )
                 ENDIF
+!
+!--             Organic carbon
+                IF ( index_oc > 0 )  THEN
+                   ic = cc_i_mod(2)
+                   CALL set_mass_flux( surface, m, ib, index_oc, mass_fracs(ic),arhooc,            &
+                                       source_array(j,i,ib) )
+                ENDIF
+!
 !--             Black carbon
-                IF ( ibc > 0 ) THEN
-                   CALL set_mass_source( k, j, i, ibc, emission_mass_fracs(1,3),&
-                                         arhobc, source_ijka, fillval )
+                IF ( index_bc > 0 )  THEN
+                   ic = cc_i_mod(3)
+                   CALL set_mass_flux( surface, m, ib, index_bc, mass_fracs(ic), arhobc,           &
+                                       source_array(j,i,ib) )
                 ENDIF
+!
 !--             Dust
-                IF ( idu > 0 ) THEN
-                   CALL set_mass_source( k, j, i, idu, emission_mass_fracs(1,4),&
-                                         arhodu, source_ijka, fillval )
+                IF ( index_du > 0 )  THEN
+                   ic = cc_i_mod(4)
+                   CALL set_mass_flux( surface, m, ib, index_du, mass_fracs(ic), arhodu,           &
+                                       source_array(j,i,ib) )
                 ENDIF
+!
 !--             Sea salt
-                IF ( iss > 0 ) THEN
-                   CALL set_mass_source( k, j, i, iss, emission_mass_fracs(1,5),&
-                                         arhoss, source_ijka, fillval )
+                IF ( index_ss > 0 )  THEN
+                   ic = cc_i_mod(5)
+                   CALL set_mass_flux( surface, m, ib, index_ss, mass_fracs(ic), arhoss,           &
+                                       source_array(j,i,ib) )
                 ENDIF
+!
 !--             Nitric acid
-                IF ( ino > 0 ) THEN
-                   CALL set_mass_source( k, j, i, ino, emission_mass_fracs(1,6),&
-                                         arhohno3, source_ijka, fillval )
+                IF ( index_no > 0 )  THEN
+                    ic = cc_i_mod(6)
+                   CALL set_mass_flux( surface, m, ib, index_no, mass_fracs(ic), arhohno3,         &
+                                       source_array(j,i,ib) )
                 ENDIF
+!
 !--             Ammonia
-                IF ( inh > 0 ) THEN
-                   CALL set_mass_source( k, j, i, inh, emission_mass_fracs(1,7),&
-                                         arhonh3, source_ijka, fillval )
+                IF ( index_nh > 0 )  THEN
+                    ic = cc_i_mod(7)
+                   CALL set_mass_flux( surface, m, ib, index_nh, mass_fracs(ic), arhonh3,          &
+                                       source_array(j,i,ib) )
                 ENDIF
-!                             
-!--             Save aerosol number sources in the end                            
-                DO  b = 1, nbins
-                   IF ( source_ijka(b) /= fillval )                            &
-                   aerosol_number(b)%source(k,j,i) =                           &
-                      aerosol_number(b)%source(k,j,i) + source_ijka(b)
-                ENDDO                     
-             ENDDO    ! k
-          ENDDO    ! j
-       ENDDO    ! i
-
-    ELSE      
-       message_string = 'NetCDF attribute lod is not set properly.'
-       CALL message( 'salsa_mod: salsa_set_source','SA0026', 1, 2, 0, 6, 0 )
-    ENDIF 
- 
-#endif    
- END SUBROUTINE salsa_set_source
- 
+
+             ENDIF
+!
+!--          Save number fluxes in the end
+             surface%answs(m,ib) = surface%answs(m,ib) + source_array(j,i,ib) * rho_air_zw(k-1)
+             aerosol_number(ib)%source(j,i) = aerosol_number(ib)%source(j,i) + surface%answs(m,ib)
+
+          ENDDO  ! ib
+       ENDDO  ! m
+
+    END SUBROUTINE set_flux
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Sets the mass emissions to aerosol arrays in 2a and 2b.
+!------------------------------------------------------------------------------!
+    SUBROUTINE set_mass_flux( surface, surf_num, ib, ispec, mass_frac, prho, nsource )
+
+       USE arrays_3d,                                                                              &
+           ONLY:  rho_air_zw
+
+       USE surface_mod,                                                                            &
+           ONLY:  surf_type
+
+       IMPLICIT NONE
+
+       INTEGER(iwp) ::  i   !< loop index
+       INTEGER(iwp) ::  j   !< loop index
+       INTEGER(iwp) ::  k   !< loop index
+       INTEGER(iwp) ::  ic  !< loop index
+
+       INTEGER(iwp), INTENT(in) :: ib        !< Aerosol size bin index
+       INTEGER(iwp), INTENT(in) :: ispec     !< Aerosol species index
+       INTEGER(iwp), INTENT(in) :: surf_num  !< index surface elements
+
+       REAL(wp), INTENT(in) ::  mass_frac    !< mass fraction of a chemical compound in all bins
+       REAL(wp), INTENT(in) ::  nsource      !< number source (#/m2/s)
+       REAL(wp), INTENT(in) ::  prho         !< Aerosol density
+
+       TYPE(surf_type), INTENT(inout) ::  surface  !< respective surface type
+!
+!--    Get indices of respective grid point
+       i = surface%i(surf_num)
+       j = surface%j(surf_num)
+       k = surface%k(surf_num)
+!
+!--    Subrange 2a:
+       ic = ( ispec - 1 ) * nbins_aerosol + ib
+       surface%amsws(surf_num,ic) = surface%amsws(surf_num,ic) + mass_frac * nsource *             &
+                                    aero(ib)%core * prho * rho_air_zw(k-1)
+       aerosol_mass(ic)%source(j,i) = aerosol_mass(ic)%source(j,i) + surface%amsws(surf_num,ic)
+!
+!--    Subrange 2b:
+       IF ( .NOT. no_insoluble )  THEN
+          CALL location_message( '    salsa_mass_flux: All emissions are soluble!', .TRUE. )
+       ENDIF
+
+    END SUBROUTINE set_mass_flux
+
+ END SUBROUTINE salsa_emission_setup
+
 !------------------------------------------------------------------------------!
 ! Description:
